# -*- coding: ISO-8859-1 -*-
""" capellaScript -- Copyright (c) 2015 Peter Becker
>>> Ziach_nach_Noten : Umsetzen von Ziach Griffschrift in Notenschrift||
    Dieses Skript ist der Nachfolger der ehemals 2 Module Ziach_nach_Noten_A und _B||
    Bei Problemen bitte eine Mail an peter_becker@freenet.de
<<<
"""
# 18.03.2015  Version 2.0.0
# 04.08.2017  Version 2.0.1  Anpassung an Python 2.7 wg. Capella 8


from Tkinter import *
from caplib.capDOM import *
import xml.dom.minidom
import tempfile, math, xml.dom

global score
doc        = [] # parentNode von score

# Druck - Darstellung mit Kreuz
DruckKreuz = dict(
                  E4 = dict(wert='C6' , kreuz='1' ),
                  G4 = dict(wert='G4' , kreuz='0' ),
                  A4 = dict(wert='C5' , kreuz='0' ),
                  B4 = dict(wert='B4' , kreuz='0' ),
                  C5 = dict(wert='E5' , kreuz='0' ),
                  D5 = dict(wert='D5' , kreuz='0' ),
                  E5 = dict(wert='G5' , kreuz='0' ),
                  F5 = dict(wert='G5' , kreuz='0' ),
                  G5 = dict(wert='C6' , kreuz='0' ),
                  A5 = dict(wert='B5' , kreuz='0' ),
                  B5 = dict(wert='E6' , kreuz='0' ),
                  C6 = dict(wert='D6' , kreuz='0' ),
                  D6 = dict(wert='G6' , kreuz='0' ),
                  E6 = dict(wert='G6' , kreuz='0' ),
                  F6 = dict(wert='C7' , kreuz='0' ),
                  G6 = dict(wert='B6' , kreuz='0' ),
                  A6 = dict(wert='E7' , kreuz='0' ),
                  B6 = dict(wert='D7' , kreuz='0' ),
                  C7 = dict(wert='G7' , kreuz='0' ),
                  D7 = dict(wert='G7' , kreuz='0' ),
                  E7 = dict(wert='C8' , kreuz='0' ),
                  F7 = dict(wert='B7' , kreuz='0' )
                  )

# Druck - Darstellung nur Kopf
DruckKopf =  dict(
                  E4 = dict(wert='A3' , kreuz='0' ),
                  F4 = dict(wert='D4' , kreuz='0' ),
                  G4 = dict(wert='C4' , kreuz='1' ),
                  A4 = dict(wert='F4' , kreuz='1' ),
                  B4 = dict(wert='E4' , kreuz='0' ),
                  C5 = dict(wert='A4' , kreuz='0' ),
                  D5 = dict(wert='A4' , kreuz='0' ),
                  E5 = dict(wert='D5' , kreuz='0' ),
                  F5 = dict(wert='C5' , kreuz='1' ),
                  G5 = dict(wert='F5' , kreuz='1' ),
                  A5 = dict(wert='E5' , kreuz='0' ),
                  B5 = dict(wert='A5' , kreuz='0' ),
                  C6 = dict(wert='A5' , kreuz='0' ),
                  D6 = dict(wert='D6' , kreuz='0' ),
                  E6 = dict(wert='C6' , kreuz='1' ),
                  F6 = dict(wert='F6' , kreuz='1' ),
                  G6 = dict(wert='E6' , kreuz='0' ),
                  A6 = dict(wert='A6' , kreuz='0' ),
                  B6 = dict(wert='A6' , kreuz='0' ),
                  C7 = dict(wert='D7' , kreuz='0' ),
                  D7 = dict(wert='C7' , kreuz='1' ),
                  E7 = dict(wert='F7' , kreuz='1' ),
                  F7 = dict(wert='E7' , kreuz='0' ),
                  G7 = dict(wert='A7' , kreuz='0' ),
                  A7 = dict(wert='A7' , kreuz='0' )
                  )

# Zug - Darstellung mit Kreuz G4 = dict(wert='C5' , kreuz='0' ),
ZugKreuz   = dict(
                  E4 = dict(wert='C6' , kreuz='1' ),
                  G4 = dict(wert='C5' , kreuz='0' ),
                  A4 = dict(wert='F5' , kreuz='0' ),
                  B4 = dict(wert='D5' , kreuz='0' ),
                  C5 = dict(wert='G5' , kreuz='0' ),
                  D5 = dict(wert='F5' , kreuz='1' ),
                  E5 = dict(wert='B5' , kreuz='0' ),
                  F5 = dict(wert='A5' , kreuz='0' ),
                  G5 = dict(wert='D6' , kreuz='0' ),
                  A5 = dict(wert='C6' , kreuz='0' ),
                  B5 = dict(wert='F6' , kreuz='0' ),
                  C6 = dict(wert='D6' , kreuz='0' ),
                  D6 = dict(wert='G6' , kreuz='0' ),
                  E6 = dict(wert='F6' , kreuz='1' ),
                  F6 = dict(wert='B6' , kreuz='0' ),
                  G6 = dict(wert='A6' , kreuz='0' ),
                  A6 = dict(wert='D7' , kreuz='0' ),
                  B6 = dict(wert='C7' , kreuz='0' ),
                  C7 = dict(wert='F7' , kreuz='0' ),
                  D7 = dict(wert='E7' , kreuz='0' ),
                  E7 = dict(wert='A7' , kreuz='0' ),
                  F7 = dict(wert='F7' , kreuz='1' )
                  )

# Zug - Darstellung nur Kopf
ZugKopf    = dict(
                  E4 = dict(wert='D4' , kreuz='0' ),
                  F4 = dict(wert='G4' , kreuz='0' ),
                  G4 = dict(wert='E4' , kreuz='0' ), 
                  A4 = dict(wert='A4' , kreuz='0' ),
                  B4 = dict(wert='G4' , kreuz='1' ),
                  C5 = dict(wert='C5' , kreuz='1' ),
                  D5 = dict(wert='B4' , kreuz='0' ),
                  E5 = dict(wert='E5' , kreuz='0' ),
                  F5 = dict(wert='D5' , kreuz='0' ),
                  G5 = dict(wert='G5' , kreuz='0' ),
                  A5 = dict(wert='F5' , kreuz='1' ),
                  B5 = dict(wert='A5' , kreuz='0' ),
                  C6 = dict(wert='G5' , kreuz='1' ),
                  D6 = dict(wert='C6' , kreuz='1' ),
                  E6 = dict(wert='B5' , kreuz='0' ),
                  F6 = dict(wert='E6' , kreuz='0' ),
                  G6 = dict(wert='D6' , kreuz='0' ),
                  A6 = dict(wert='G6' , kreuz='0' ),
                  B6 = dict(wert='F6' , kreuz='1' ),
                  C7 = dict(wert='B6' , kreuz='0' ),
                  D7 = dict(wert='G6' , kreuz='1' ),
                  E7 = dict(wert='C7' , kreuz='1' ),
                  F7 = dict(wert='B6' , kreuz='0' ),
                  G7 = dict(wert='E7' , kreuz='0' ),
                  A7 = dict(wert='D7' , kreuz='0' )
                  )                  

# y Offset der Notenkpfe

KopfOffset = dict(E4 = '5.5',F4 = '5',G4 = '4.5',A4 = '4', B4 = '3.5',
                  C5 = '3',D5 = '2.5',E5 ='2',F5 = '1.5',G5 = '1',A5 = '0.5',B5 ='0',
                  C6 = '-0.5',D6 = '-1',E6 = '-1.5',F6 = '-2',G6 = '-2.5',A6 = '-3',B6 = '-3.5',
                  C7 = '-4',D7 = '-4.5',E7 = '-5',F7 = '-5.5',G7 = '-6',A7 ='-6.5')

def latin1_d(u):
    return u.decode('Latin-1')

def addElementNode(el,tagName,score):
    # Neue Node zu "el" hinzufgen wenn Node "tagName" nicht existiert
    # ansonsten existierende Node zurckmelden
     
    childs = el.childNodes
    for n in range(childs.length):
        if childs[n].nodeType ==childs[n].ELEMENT_NODE and childs[n].tagName == tagName:
            return childs[n]
    newChild = score.parentNode.createElement(tagName)
    el.appendChild(newChild)
    return newChild

class ZiachB(ScoreChange):
    
    def changeScore(self, score):
        #messageBox('SCORECHANGE','neue Klasse') 
        for system in score.getElementsByTagName('system'):              # nur 1 Zeile stehen lassen
            staffs = 0
            for staff in system.getElementsByTagName('staff'):
                if staffs <> 0:
                    staff.parentNode.removeChild(staff)
                staffs = staffs + 1
                
            for nOs in system.getElementsByTagName('noteObjects'):        # alles ausser 'chords' schwarz frben
                childs = nOs.childNodes
                #messageBox('CHILDS',str(childs))
                clef = 0
                for n in range(childs.length):
                    if childs[n].nodeType ==childs[n].ELEMENT_NODE and childs[n].tagName == 'clefSign':
                        clef = 1
                    if childs[n].nodeType ==childs[n].ELEMENT_NODE and childs[n].tagName == 'barline':
                        if childs[n].hasAttribute('color'):
                            childs[n].removeAttribute('color')
                    if childs[n].nodeType ==childs[n].ELEMENT_NODE and childs[n].tagName <> 'chord':
                       display = childs[n].getElementsByTagName('display')
                       if display:
                           if display[0].hasAttribute('color'):
                               display[0].removeAttribute('color')

                if clef == 0:                                             # falls kein Schlssel in der Zeile
                    newChild = score.parentNode.createElement('clefSign') # Violinschlssel einfgen
                    for n in range(childs.length):
                        if childs[n].nodeType ==childs[n].ELEMENT_NODE:
                            fc = childs[n]
                            nOs.insertBefore(newChild,fc)
                            break
                for cl in nOs.getElementsByTagName('clefSign'):
                    cl.setAttribute('clef','treble')

                for rs in nOs.getElementsByTagName('rest'):
                    for do in rs.getElementsByTagName('drawObj'):     # Druckbalken an Pausen entfernen
                        for ln in do.getElementsByTagName('line'):
                            do.parentNode.removeChild(do)
                    
                for no in nOs.getElementsByTagName('chord'):
                    #messageBox('NO',str(no))
                    display = no.getElementsByTagName('display')
                    color ='000000'
                    if display:
                        color = display[0].getAttribute('color')       # Balgrichtung extrahieren
                        #if color == '0000FF' or color == 'FF0000':
                    pitch = []   # Tonhhe der Kpfe am Notenhals
                    pos   = []   # y-Position vorhandener DrawObjects am Notenhals
                    heads = []   # Kopf, Elemente am Notenhals
                    kreuz = []   # Kopf hat Kreuz, yes/no
                    form  = []   # Kopfform aus Original
                    alter = []   # Doppelkreuz als Vorzeichen 
                    if color == '0000FF': richtung = 'D'
                    else: richtung = 'Z'
                            
                    for hd in no.getElementsByTagName('head'):
                        pitch1 = hd.getAttribute('pitch')      # Tonhhe extrahieren
                        pitch.append(str(pitch1))
                        heads.append(hd)                       # und merken
                        form1 = "no"
                        if hd.hasAttribute('shape'):
                            form1 = hd.getAttribute('shape')
                            if form1 <> "crossCircle":
                                form1 = "no"
                            hd.removeAttribute('shape')
                        form.append(str(form1))                # falls Kopfform crossCircle, dies merken
                        alt = hd.getElementsByTagName('alter')
                        alter1 = "no"
                        if alt:
                            alter1 = alt[0].getAttribute('step')
                            if alter1 <> "2":
                                alter1 = "no"     
                        alter.append(str(alter1))              # falls Doppelkreuz als Vorzeichen, dies merken
                                
                    for do in no.getElementsByTagName('drawObj'):   # Kreuze feststellen und Position merken
                        for ln in do.getElementsByTagName('line'):
                            do.parentNode.removeChild(do)           # Druckbalken weg
                        for tx in do.getElementsByTagName('text'):
                            if tx:
                                y  = tx.getAttribute('y') 
                                font = tx.getElementsByTagName('font')
                                face = font[0].getAttribute('face')
                                if face == 'Ziach':
                                    do.parentNode.removeChild(do)   # weg mit TAB Schlssel                                        
                                if face == 'capella3':
                                    content = tx.getElementsByTagName('content')
                                    data = content[0].firstChild.data
                                    if data == 'T' or data == u'\xee':    # Position normalisiere n.5 oder n.0
                                        y1 = math.modf(float(y))
                                        z = y1[1]
                                        n = y1[0]
                                        y = float(y)
                                        #messageBox('X1',str(y) + '\n' + str(y1) + '\n' + str(z) + '\n' + str(n))
                                        if y >= 0:                  # positives offset
                                            #messageBox('Y+',str(y))
                                            if n <= 0.25:
                                                n = 0
                                            elif n > 0.25 and n <= 0.5:
                                                n = 0.5
                                            elif n <= 0.75 and n >= 0.5:
                                                n = 0.5
                                            elif n > 0.75:
                                                n = 0
                                                z = z + 1
                                            y2 = n + z
                                        else:                       # negatives offset
                                            #messageBox('Y-',str(y))
                                            if n >= -0.25:
                                                n = 0
                                                #messageBox('Y1',str(n))
                                            elif n < -0.25 and n >= -0.5:
                                                n = -0.5
                                                #messageBox('Y2',str(n))
                                            elif n >= -0.75 and n <= -0.5:
                                                n = -0.5
                                                #messageBox('Y3',str(n))
                                            elif n < -0.75:
                                                n = 0
                                                z = z - 1
                                                #messageBox('Y4',str(n))
                                        y2 = n + z
                                        #messageBox('X2',str(y) + '\n' + str(y1) + '\n' + str(z) + '\n' + str(n) + '\n' + str(y2))    

                                        pos.append(str(y2))             # y-Position merken
                                        do.parentNode.removeChild(do)   # weg mit den Kreuzen oder Triangeln
                                                
                    if pitch:
                        #messageBox('NOs',str(pitch) + '\n' + str(pos) + '\n' + str(heads))
                        
                        for ix1 in range(len(pitch)):                 # testen ob Ton ein Kreuz hat
                            off = str(float(KopfOffset[pitch[ix1]]))
                            kr = 'no'
                            if off in pos:
                                kr = 'yes'
                                #messageBox('Step1','Step 1')
                            else:
                                fo = form[ix1]
                                al = alter[ix1]
                                #messageBox('Step2','Step 2')
                                if fo == 'crossCircle':
                                    kr = 'yes'
                                    #messageBox('Step3','Step 3')
                                elif al == '2':
                                    #messageBox('Step4','Step 4')
                                    kr = 'yes'
                                else:
                                    #messageBox('Step5','Step 5')
                                    kr = 'no'
                            kreuz.append(kr)                          # merken welcher Kopf ein Kreuz hat und welcher nicht
                            #messageBox('Kreuz',str(kreuz))
                            #messageBox('NOs',str(off) + '\n' + str(pos) + '\n' + str(kr) + '\n' + str(richtung))
                        for ix3 in range(len(pitch)):                 # bersetzen
                            if richtung == 'D' and kreuz[ix3] == 'yes':
                                #messageBox('NOs',str(off) + '\n' + str(pos) + '\n' + str(kr) + '\n' + str(richtung) + '\n' + str(pitch[ix3]))
                                headneu = DruckKreuz[pitch[ix3]]['wert']
                                vorzneu = DruckKreuz[pitch[ix3]]['kreuz']
                                #messageBox('bersetzt bei Druck und Kreuz',str(headneu) + '    ' + str(vorzneu))
                            elif richtung == 'Z' and kreuz[ix3] == 'yes':
                                headneu = ZugKreuz[pitch[ix3]]['wert']
                                vorzneu = ZugKreuz[pitch[ix3]]['kreuz']
                            elif richtung == 'D' and kreuz[ix3] == 'no':
                                headneu = DruckKopf[pitch[ix3]]['wert']
                                vorzneu = DruckKopf[pitch[ix3]]['kreuz']
                            else:
                                headneu = ZugKopf[pitch[ix3]]['wert']
                                vorzneu = ZugKopf[pitch[ix3]]['kreuz']
                            #messageBox('',str(pitch[ix3]) + '\n' +  str(headneu)+ '\n' +  str(vorzneu)) 
                            heads[ix3].setAttribute('pitch',str(headneu))                            
                            alter = addElementNode(heads[ix3],'alter',score)
                            #messageBox('yy',str(alter) + '\nvorzneu=' + str(vorzneu))
                            for dp in no.getElementsByTagName('display'):   # wieder schwarz frben
                                if dp.hasAttribute('color'):
                                    dp.removeAttribute('color')
                            if alter.hasAttribute('display'):         # display=suppress lschen um Vorzeichen anzuzeigen
                                    alter.removeAttribute('display')
                            if vorzneu == '1':
                                alter.setAttribute('step','1')
                            else:
                                alter.parentNode.removeChild(alter)   # weg mit 'alter', wird nicht bentigt
                                
                    heads = []
                    pos   = []
                    pitch = []
                    kreuz = []   

class MarkedScoreChange (ScoreChange):
    def __init__(self, inputFile, outputFile, cursor1, cursor2):
        self.sysI1, self.staffI1, self.voiceI1, self.objI1 = cursor1
        self.sysI2,self.staffI2,self.voiceI2,self.objI2 = cursor2
        self.sysCurrent = 0
        self.staffCurrent = 0
        self.voiceCurrent = 0
        self.objCurrent = 0
        self.lastchord = 0
#        messageBox("__init__: objI1, objI2", str(self.objI1)+', '+str(self.objI2))
        ScoreChange.__init__(self, inputFile, outputFile)
        
    def copyElement(self, el):
        ScoreChange.copyElement(self, el)
        # Positionsmerker aktualisieren
        if el.tagName == 'system':
            self.sysCurrent = self.sysCurrent + 1
            self.staffCurrent = 0
            self.voiceCurrent = 0
            self.objCurrent = 0
        if el.tagName == 'staff':
            self.staffCurrent = self.staffCurrent + 1
            self.voiceCurrent = 0
            self.objCurrent = 0
        if el.tagName == 'voice':
            self.voiceCurrent = self.voiceCurrent + 1
            self.objCurrent = 0
        if el.tagName in ['clefSign','keySign','timeSign','chord','rest','barline']:
            self.objCurrent = self.objCurrent + 1
            
    def isInMarkedArea(self):
        if self.sysI1 <= self.sysCurrent and self.sysCurrent < self.sysI2:
            return True
        if self.sysI1 == self.sysCurrent and self.sysCurrent == self.sysI2 \
           and self.staffI1 == self.staffCurrent \
           and self.voiceI1 == self.voiceCurrent \
           and self.objI1 <= self.objCurrent and self.objCurrent < self.objI2:
            return True
        return False


class BlockScoreChange (MarkedScoreChange):
    
    def changeElement(self, el):
        global id, FarbenListeX 
        FarbIx = id[0]-1
        #messageBox('ID',str(id))
        if self.isInMarkedArea() and FarbIx <= 15:
            if el.tagName in ['chord','rest']:
                olddisplays = el.getElementsByTagName('display')
                if olddisplays:
                    display = olddisplays[0]
                else:
                    display = self.doc.createElement('display')
                    el.appendChild(display)   
                display.setAttribute('color',FarbenListeX[FarbIx])
            elif el.tagName in ['barline','clefSign','timeSign','keySign']:
                FarbIx = id[0]-1
                el.setAttribute('color',FarbenListeX[FarbIx])
                

def zeige(event):
    global asc, start, stop, id, hauptfenster
    w  = event.widget
    id = w.find_overlapping(event.x,event.y,event.x,event.y)
    sel = curSelection()
    start = sel[0]
    stop = sel[1]
    if id[0] == 2 or id[0] == 4:
        BlockFaerben(asc, start, stop)
    elif id[0] == 7:
        hauptfenster.destroy()
        #messageBox('Feierabend','OK')
        # jetzt geht es zur bersetzung
        
        activeScore().registerUndo("Ziach_nach_Noten")
        tempInput = tempfile.mktemp('.capx')
        tempOutput = tempfile.mktemp('.capx')
        activeScore().write(tempInput)
        
        ZiachB(tempInput, tempOutput)
    
        activeScore().read(tempOutput)
        os.remove(tempInput)
        os.remove(tempOutput)
        
def BlockFaerben(score,(sysind, staffind, voiceind, objind),(sysind2, staffind2, voiceind2, objind2)):
    global asc, start, stop, id
    #messageBox('SCORE',str(score))
    sys = score.system(sysind)
    staff = sys.staff(staffind)
    voice = staff.voice(voiceind)
    no = voice.nNoteObjs()
    if objind <= no and objind2 <= no:
            # falls rckwrts markiert wurde.
            if objind > objind2:
                obji = objind
                objind = objind2
                objind2 = obji
            firstobj = voice.noteObj(objind)
            
            score.registerUndo("Ziach_nach_Noten")
            tempFile1 = tempfile.mktemp('.capx')
            tempFile2 = tempfile.mktemp('.capx')
            score.write(tempFile1)
            BlockScoreChange(tempFile1,tempFile2,(sysind, staffind, voiceind, objind),\
                            (sysind, staffind, voiceind, objind2))
            score.read(tempFile2)
            os.remove(tempFile1)
            os.remove(tempFile2)
            

# Hauptprogramm Teil 1, Vorbereitung auf die bersetzung
from caplib.capDOM import ScoreChange
import tempfile, xml.dom

global asc, FarbenListe, FarbenlisteX, hauptfenster, score
asc = activeScore()

FarbenListe=[('#00F'),# blau
             ('#F00'),# rot
             ('#F80'),# orange
             ('#F80'),# orange
             ('#FC0'),# orangegelb
             ('#FF0'),# gelb
             ('#AF0'),# gelbgelbgrn
             ('#8F0'),# gelbgrn
             ('#0E0'),# grn
             ('#078'),# blaugrn
             ('#039'),# grnblau
             ('#60A'),# violett
             ('#E05'),# rotviolett
             ('#000'),# schwarz
             ('#888'),# dunkelgrau
             ('#CCC'),# hellgrau
             ('#FFF')]# weiss

FarbenListeX=[('FF8000'),# orange
              ('0000FF'),# blau
              ('FFC000'),# orangegelb
              ('000000'),# schwarz              
              ('FFFF00'),# gelb
              ('FFC000'),# orangegelb
              ('A0FF00'),# gelbgelbgrn
              ('80FF00'),# gelbgrn
              ('00E000'),# grn
              ('007080'),# blaugrn
              ('003090'),# grnblau
              ('0000FF'),# blau
              ('6000A0'),# violett
              ('E00050'),# rotviolett
              ('000000'),# schwarz
              ('FF0000'),# rot
              ('808080'),# dunkelgrau
              ('C0C0C0'),# hellgrau
              ('FFFFFF')]# weiss

if asc:
    hauptfenster = Tk()
    hauptfenster.title('Balgrichtung "Druck" markieren')
    canvas = Canvas(hauptfenster,height='4.5c',width='8.5c',bg='white')
    canvas.grid()
    t1  = canvas.create_text(143,20,text='Bereich mit dem Cursor markieren und Richtung anklicken')
    r1  = canvas.create_rectangle(20,40,260,60,fill=FarbenListe[0])
    t2  = canvas.create_text(136,50,text='auf Druck spielen',fill=FarbenListe[16],font='Arial')
    r2  = canvas.create_rectangle(20,70,260,90,fill=FarbenListe[13])
    t3  = canvas.create_text(135,80,text='auf Zug spielen (Korrektur)',fill=FarbenListe[16],font='Arial')
    t4  = canvas.create_text(135,110,text='wenn alles markiert ist, bersetzen anklicken')
    r3  = canvas.create_rectangle(20,130,260,150,fill=FarbenListe[9])
    t5  = canvas.create_text(135,140,text='bersetzen',fill=FarbenListe[16],font='Arial')
    
    canvas.bind('<Button-1>',zeige)
    hauptfenster.mainloop()